Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 340107)
+++ channels/chan_sip.c	(working copy)
@@ -6945,10 +6945,13 @@
 	 * we should decode the uri before storing it in the channel, but leave it encoded in the sip_pvt
 	 * structure so that there aren't issues when forming URI's
 	 */
+	ast_channel_unlock(tmp);
 	if (ast_exists_extension(NULL, i->context, i->exten, 1, i->cid_num)) {
+		ast_channel_lock(tmp);
 		/* encoded in dialplan, so keep extension encoded */
 		ast_copy_string(tmp->exten, i->exten, sizeof(tmp->exten));
 	} else {
+		ast_channel_lock(tmp);
 		decoded_exten = ast_strdupa(i->exten);
 		ast_uri_decode(decoded_exten);
 		ast_copy_string(tmp->exten, decoded_exten, sizeof(tmp->exten));
